#ifndef BENCHMARKER_H
#define BENCHMARKER_H


class Application;

namespace Ogre
{
	class Camera;
}
#include "OgreVector3.h"
#include <sstream>


class Benchmarker
{
public:
	Benchmarker(Application* application, Ogre::Camera* camera);
	~Benchmarker();

	void update(float time);
	bool isFinished() const;
private:
	void updateCamera();
	void switchToNextPhase();

	Application* mApplication;
	Ogre::Camera* mCamera;

	float mTimeInCurrentPhase;
	int mCurrentPhase, mNumPhases;
	bool mRotationMovement;
	unsigned int mFramesRendered;
	const float mMeasureStartTime, mMeasureEndTime;
	const Ogre::Vector3 mCamStartPos, mCamEndPos;

	bool mIsFinished;

	std::stringstream mResultText;
};


#endif //BENCHMARKER_H